<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'DibStatBubbles',
  props: {
    data: {
      type: Array,
      required: true,
      default: null,
    },
  },
  mounted() {
    const observer = new IntersectionObserver(
      (entries) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            entry.target.classList.add('animate');
            entry.target
              .querySelector('.filled-circle-text')
              .classList.add('animate');
            observer.unobserve(entry.target);
          }
        });
      },
      { threshold: 0.1 },
    );

    this.$el.querySelectorAll('.filled-circle-wrapper').forEach((wrapper) => {
      observer.observe(wrapper);
    });
  },
});
</script>

<template>
  <div class="filled-circle-section">
    <div
      v-for="circle in data"
      :key="circle.label"
      class="filled-circle-wrapper"
      :class="circle.color"
    >
      <div class="filled-circle"></div>
      <div class="filled-circle-text">
        <p>
          <span class="number"> {{ circle.number }}% </span>
        </p>
        <p class="label">
          {{ circle.label }}
        </p>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.filled-circle-section {
  position: relative;
  min-height: 300px;

  @media (max-width: $breakpoint-md) {
    min-height: 600px;
  }

  .filled-circle-wrapper {
    position: absolute;
    display: block;
    flex-shrink: 1;
    border-radius: 50%;
    opacity: 0.1;
    transform: scale(0.1);
    transition:
      transform 0.5s ease-out,
      opacity 0.5s ease-out;

    &.animate {
      opacity: 1;
      transform: scale(1);
    }

    .filled-circle-text {
      position: absolute;
      text-align: center;
      z-index: 1;
      font-weight: $font-weight-bold;
      opacity: 0;
      transition: opacity 1s ease-out 1s;

      &.animate {
        opacity: 1;
      }
    }

    &.orange {
      background: #ffddc0;
    }

    &.pink {
      background: #fae9f1;
    }

    &.purple {
      background: #efe6fd;
    }

    .filled-circle {
      border-radius: 50%;
      z-index: 0;
      opacity: 0.1;
      transform: scale(0.1);
      transition:
        transform 1s ease-out,
        opacity 1s ease-out;
    }

    &.animate .filled-circle {
      opacity: 1;
      transform: scale(1);
    }

    @media (prefers-reduced-motion: reduce) {
      transition: none;

      &.animate {
        opacity: 1;
        transform: none;
      }

      .filled-circle-text {
        opacity: 1;
        transition: none;
      }

      .filled-circle {
        opacity: 1;
        transform: none;
        transition: none;
      }
    }

    &:first-of-type {
      width: 90px;
      height: 90px;
      left: 6%;
      top: 50%;
      transform: translateY(-50%);

      .filled-circle-text {
        top: 30%;
        left: 5%;
        width: 100%;

        .number {
          font-size: 32px;
        }

        .label {
          font-size: 16px;
          line-height: 24px;
        }
      }

      @media (max-width: $breakpoint-md) {
        top: 20%;
      }
    }

    &:nth-of-type(2) {
      width: 190px;
      height: 190px;
      top: 50%;
      transform: translateY(-50%);
      left: 19%;

      .filled-circle-text {
        top: 38%;
        left: 23%;

        .number {
          font-size: 48px;
        }

        .label {
          font-size: 18px;
          line-height: 32px;
        }
      }

      @media (max-width: $breakpoint-md) {
        top: 45%;
      }
    }

    &:nth-of-type(3) {
      width: 140px;
      height: 140px;
      top: 63%;
      left: 36%;

      .filled-circle-text {
        top: 33%;
        left: 28%;

        .number {
          font-size: 32px;
        }

        .label {
          font-size: 20px;
          line-height: 24px;
        }
      }

      @media (max-width: $breakpoint-md) {
        top: 65%;
        left: 50%;
      }
    }

    &:nth-of-type(4) {
      width: 121px;
      height: 121px;
      top: 50%;
      transform: translateY(-50%);
      left: 49%;

      .filled-circle-text {
        top: 30%;
        left: 18%;

        .number {
          font-size: 32px;
        }

        .label {
          font-size: 20px;
          line-height: 24px;
        }
      }

      @media (max-width: $breakpoint-md) {
        top: 70%;
        left: 0;
      }
    }

    &:nth-of-type(5) {
      width: 95px;
      height: 95px;
      top: 25%;
      left: 62%;

      .filled-circle-text {
        top: 26%;
        left: 28%;

        .number {
          font-size: 28px;
        }

        .label {
          font-size: 16px;
          line-height: 24px;
        }
      }

      @media (max-width: $breakpoint-md) {
        top: 85%;
        left: 15%;
      }
    }

    &:nth-of-type(6) {
      width: 40px;
      height: 40px;
      top: 65%;
      left: 72%;

      .filled-circle-text {
        top: 20%;
        left: -80%;

        @-moz-document url-prefix() {
          left: -30%; // overrides weird firefox positioning bug
        }

        .number {
          font-size: 16px;
        }

        .label {
          margin-top: 10px;
          font-size: 14px;
          line-height: 18px;
        }
      }

      @media (max-width: $breakpoint-md) {
        width: 60px;
        height: 60px;
        top: 105%;
        left: 20%;

        .filled-circle-text {
          top: 30%;
          left: -45%;

          .number {
            font-size: 18px;
          }

          .label {
            margin-top: 25px;
            font-size: 16px;
            line-height: 18px;
          }
        }
      }
    }

    &:nth-of-type(7) {
      width: 65px;
      height: 65px;
      top: 50%;
      transform: translateY(-50%);
      left: 79%;

      .filled-circle-text {
        top: 33%;
        left: 0%;

        .number {
          font-size: 21px;
        }

        .label {
          margin-top: 20px;
          font-size: 16px;
          line-height: 18px;
        }
      }
      @media (max-width: $breakpoint-md) {
        top: 100%;
        left: 60%;
      }
    }
  }
}
</style>
